%{
// Definicje etonw pochodzce z Bisona
#include "skalk.tab.h"

// Tablica zmiennych 
char *dict[1000];
int dict_size=0;

// Odnajduje nazwe zmiennej w tablicy, lub j dodaje
int dict_find(const char *key) {
    int i;
    for(i=0; i<dict_size; i++) if (strcmp(key,dict[i])==0) return i;
    
    i=dict_size; dict_size++;
    dict[i]=(char *)malloc(strlen(key)+1);
    strncpy(dict[i],key,strlen(key)+1);
    return i;
}

%}

INT     [0-9]+
ID      [A-Za-z][A-Za-z0-9]*

%%

PRINT { return CMD_PRINT; }
SET   { return CMD_SET;   }

{ID}  { 
	yylval=dict_find(yytext);
	return ID; 
      }

{INT} { 
        yylval=atoi(yytext); 
	return NUM; 
      }

[ \t] { /* Nic */ }

[\n]|. { return yytext[0]; }  

%%
