function SymulatorAutomatu(pozycje,przejscia,stan_poczatkowy,tekst,e_id) // object prototype
{
  var pos = 0;          
  var n = 0;
  var aktywne_stany = 0;         
  var MAXS=20;
          
  // metody prywatne
  function redraw()
  {
    tmp = new Array(MAXS);
    for(i=0;i<aktywne_stany.length;i++) tmp[aktywne_stany[i]]=1;
    
    for(i=0;i<MAXS;i++) {
        e=xGetElementById(e_id+i);
        if (!e) continue;
        if (tmp[i]) 
            xShow(e);
        else
            xHide(e);
    }
    e=xGetElementById(e_id+'wejscie');    
    html='';
    for(i=0;i<tekst.length;i++) {
        var ch=tekst.substring(i,i+1);
        if (i==pos-1) {
            html='<span class="automat_wejscie_zazn">'+html+ch+'</span>';
        } else html=html+ch;    
    }
    if (pos>=tekst.length) html='<span class="automat_wejscie_zazn">'+html+'</span>';        
    e.innerHTML=html;
  }  
  
  // Public Methods
  this.start = function()    
  {
    pos = 0;
    n = tekst.length;
    aktywne_stany = new Array;
    if (stan_poczatkowy.length) {
      for(i=0;i<stan_poczatkowy.length;i++) 
        aktywne_stany.push(stan_poczatkowy[i]);
    } else {
      aktywne_stany.push(stan_poczatkowy);
    }
    
    for(i=0;i<pozycje.length;i++) {
      x=pozycje[i][0];
      y=pozycje[i][1];
      e=xGetElementById(e_id+i);
      if (!e) continue;
      xMoveTo(e,x,y);
    }
      
    redraw();
  }
  
  
  this.stop = function()
  {
    alert("TODO - stop");
  }
  
  this.next = function() 
  {
    if (pos>=n) return; // koniec tekstu

    var ch=tekst.substring(pos,pos+1);   
    
    stare_stany = new Array(MAXS);
    for(i=0;i<aktywne_stany.length;i++) stare_stany[aktywne_stany[i]]=1;
    
    nowe_stany = new Array(MAXS);
    
    
    for(i=0;i<przejscia.length;i++) {            
       var p=przejscia[i];
       if (!stare_stany[p[0]]) continue; 
       if (p[1]!=ch) continue;
       nowe_stany[p[2]]=1;
    }
    
    
    aktywne_stany=new Array();
    
    for(i=0;i<MAXS;i++) if (nowe_stany[i]) aktywne_stany.push(i);    
    pos++;    
    redraw();    
  }
}
